/* *****************************************************************************
 *  Description:  Performs binary search on a key provided from a list of
 *                words on standard input.  Outputs the word, if found, and the
 *                number of comparisons needed.
 *
 *                java-introcs BinarySearch blahblah < words-sorted.txt
 *                java-introcs BinarySearch princeton < words-sorted.txt
 *                java-introcs BinarySearch determine < words-sorted.txt 
 *                java-introcs BinarySearch athletic < words-sorted.txt
 *
 **************************************************************************** */

public class BinarySearch {
    // main method
    public static void main(String[] args) {
        // get command-line argument and list of words
        String key = args[0];
        String[] words = StdIn.readAllStrings();
        int n = words.length;

        // keep track of comparison count
        int count = 0;

        // binary search - from lecture
        int lo = 0, hi = words.length - 1;
        while (lo <= hi) {
            int mid = lo + (hi - lo) / 2;
            int compare = key.compareTo(words[mid]);
            count = count + 1;
            if (compare < 0) hi = mid - 1;
            else if (compare > 0) lo = mid + 1;
            else {
                StdOut.println(key + " found using " + count + " comparisons.");
                return; // exit program
            }
        }
        StdOut.println(key + " not found using " + count + " comparisons.");

    }
}
