/* *****************************************************************************
 *  Description:  Performs insertion sort on 
 *                  1. Unsorted list of n integers, and
 *                  2. Sorted list of n integers
 *                 
 *                Outputs (wall clock) time to perform the sorts.
 *
 *                java-introcs InsertionSortClient  50000
 *                java-introcs InsertionSortClient 100000
 *                java-introcs InsertionSortClient 200000
 *                java-introcs InsertionSortClient 400000
 * 
 *                You can also use the -Xint flag to turn off optimization - 
 *                this may produce better results for your analysis.  However,
 *                you can use smaller values for n:  For example:
 *
 *                java-introcs -Xint InsertionSortClient 10000
 *                java-introcs -Xint InsertionSortClient 20000
 *                java-introcs -Xint InsertionSortClient 40000
 *
 **************************************************************************** */

public class InsertionSortClient {
    // create an unsorted array of n integers
    public static int[] generateUnsorted(int n) {
        int[] array = new int[n];

        for (int i = 0; i < n; i++) {
            array[i] = StdRandom.uniformInt(n);
        }

        return array;
    }

    // create an a sorted array of n integers

    // main method - takes a single command-line argument
    public static void main(String[] args) {
        // get the value n;
        int n = Integer.parseInt(args[0]);

        // Insertion sort on unsorted list
        int[] values = generateUnsorted(n);
        Stopwatch timer = new Stopwatch();
        InsertionSort.sort(values); // values is now sorted!
        StdOut.printf("Unsorted: Insertion sort %d values in %f seconds.\n",
                      n, timer.elapsedTime());

        // Insertion sort on sorted list
        timer = new Stopwatch();
        InsertionSort.sort(values);
        StdOut.printf("Sorted: Insertion sort %d values in %f seconds.\n",
                      n, timer.elapsedTime());
    }
}
