/* *****************************************************************************
 *  Description:  Performs mergsort on 
 *                  1. Unsorted list of n integers, and
 *                  2. Sorted list of n integers
 *                 
 *                Outputs (wall clock) time to perform the sorts.
 *
 *                java-introcs MergeSortClient 1000000
 *                java-introcs MergeSortClient 2000000
 *                java-introcs MergeSortClient 4000000
 *                java-introcs MergeSortClient 8000000
 *
 **************************************************************************** */

public class MergeSortClient {
    // create an unsorted array of n integers
    public static int[] generateUnsorted(int n) {
        int[] array = new int[n];

        for (int i = 0; i < n; i++) {
            array[i] = StdRandom.uniformInt(n);
        }

        return array;
    }

    // create an a sorted array of n integers
    // main method - takes a single command-line argument
    public static void main(String[] args) {
        // get the value n;
        int n = Integer.parseInt(args[0]);

        // Mergesort on unsorted list
        int[] values = generateUnsorted(n);
        Stopwatch timer = new Stopwatch();
        MergeSort.sort(values); // values is now sorted!
        StdOut.printf("Unsorted: Mergesort %d values in %f seconds.\n",
                      n, timer.elapsedTime());

        // Mergesort on sorted list
        timer = new Stopwatch();
        MergeSort.sort(values);
        StdOut.printf("Sorted: Mergesort %d values in %f seconds.\n",
                      n, timer.elapsedTime());
    }
}
