/* *****************************************************************************
 *  Description:  Performs sequential search on a key provided from a list of
 *                words on standard input.  Outputs the word, if found, and the
 *                number of comparisons needed.
 *
 *                java-introcs SequentialSearch princeton < words-sorted.txt
 *                java-introcs SequentialSearch blahblah < words-sorted.txt
 *                java-introcs SequentialSearch determine < words-sorted.txt 
 *                java-introcs SequentialSearch athletic < words-sorted.txt 
 *
 **************************************************************************** */

public class SequentialSearch {
    // main method - one command-line arg - the search word
    public static void main(String[] args) {
        String key = args[0];
        String[] words = StdIn.readAllStrings();

        int n = words.length;
        for (int i = 0; i < n; i++) {
            if (words[i].equals(key)) {
                StdOut.println(key + " found using " + (i + 1) + " comparisons.");
                return; // exit program
            }
        }
        StdOut.println(key + " not found using " + n + " comparisons.");


    }
}
